<?php

/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace FiloBlu\PrevNext\Controller\Index;

/**
 * Responsible for loading page content.
 *
 * This is a basic controller that only loads the corresponding layout file. It may duplicate other such
 * controllers, and thus it is considered tech debt. This code duplication will be resolved in future releases.
 */
class Index extends \Magento\Framework\App\Action\Action {

    /** @var \Magento\Framework\View\Result\PageFactory */
    protected $resultJsonFactory;
    protected $_helper;
   

    public function __construct(
    \Magento\Framework\App\Action\Context $context, \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory, \FiloBlu\PrevNext\Helper\Data $helper
    ) {
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_helper = $helper;
       

        parent::__construct($context);
    }

    public function execute() {
        
        if ($this->getRequest()->getParam('product_id') && $this->getRequest()->getParam('category_id')) {

            $resultJson = $this->resultJsonFactory->create();

            $resultJson->setData($this->_helper->getPrevNextAndCurrentCategoryLink($this->getRequest()->getParam('category_id'),$this->getRequest()->getParam('product_id')));

            return $resultJson;
        } else {
            return null;
        }
    }

}
