define(
        [
            'jquery',
            'ko',
            'uiComponent',
            'underscore',
            'mage/cookies'
        ],
        function ($, ko, Component, _) {
            "use strict";
            return Component.extend({
                prevNextData: {},
                initialize: function () {

                    if ($.cookie('prevnext-category-data')) {
                        this._prevNextAjax(window.prevNextProductId, $.cookie('prevnext-category-data'));
                    }

                    return this._super();
                },
                _prevNextAjax: function (product_id, category_id) {

                    var me = this;
                    $.ajax({
                        showLoader: false,
                        url: window.prevNextBaseUrl + "prevnext/",
                        data: "product_id=" + product_id + "&category_id=" + category_id,
                        type: "GET",
                        dataType: 'json'
                    }).done(function (data) {

                        if (data) {
                            me.update(data);
                        }
                    });
                },
                update: function (updatedPrevNextData) {
                    _.each(updatedPrevNextData, function (value, key) {

                        if (!this.prevNextData.hasOwnProperty(key)) {
                            this.prevNextData[key] = ko.observable();
                        }
                        this.prevNextData[key](value);
                    }, this);
                },
                /**
                 * Get prevnext data param by name.
                 * @param {String} name
                 * @returns {*}
                 */
                getPrevNextParam: function (name) {
                    if (!_.isUndefined(name)) {
                        if (!this.prevNextData.hasOwnProperty(name)) {
                            this.prevNextData[name] = ko.observable();
                        }
                    }

                    return this.prevNextData[name]();
                }

            });
        }
);